<?php
/*
 * Plugin Name: WOPshop Cart
 * Plugin URI: http://www.wop-agentur.de/wopshop/
 * Description: Cart widget for WOPshop
 * Version: 1.0.0
 * Author: MAXXmarketing GmbH
 * Author URI: http://www.wop-agentur.de
 *
 * Open Source License, GNU GPL
 */

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

if (!defined('WOPSHOP_PLUGIN_DIR')){
    return false;   
}

if (class_exists('Wopshop')){
    add_action('widgets_init', function(){
        register_widget('wshopCartWidget');
    });
}

class wshopCartWidget extends WP_Widget {
    public function __construct() {
        $config = Factory::getConfig();
        $lang = $config->getLang();
		
        if (is_file(__DIR__.'/lang/'.$lang.'.php')) {
            require_once(__DIR__.'/lang/'.$lang.'.php');
        } else {
            require_once(__DIR__.'/lang/en-GB.php');
		}
		
        parent::__construct("wshop_cart", _WSHOP_CART, array("description" => _WSHOP_CART_DESCRIPTION));
    }

    public function widget($args, $instance) {
        echo $args['before_widget'];
        $title = apply_filters( 'widget_title', $instance['title'] );
        if (!empty($title)){
            echo $args['before_title'] . $title . $args['after_title'];
        }
        
        $cart = Factory::getModel('cart');
        $cart->load("cart");
        $show_count = $instance[ 'show_count' ];
        ?>
        <div id = "wop_shop_module_cart">
            <table class = "module_cart_detail" width = "100%">
            <?php 
              $countprod = 0;
              $array_products = array();
              foreach($cart->products as $value){
                $array_products [$countprod] = $value;
            ?> 
                  <tr class="<?php  if ( ($countprod + 2) % 2 > 0) { print 'odd'; } else { print 'even'; }  ?>">
                    <td class="name"><?php print $array_products [$countprod]["product_name"]; ?></td>
                    <?php if ($show_count =='1') {?>
                    <td class="qtty"><?php print $array_products [$countprod]["quantity"]; ?> x </td>
                    <td class="summ"><?php print formatprice($array_products [$countprod]["price"]); ?></td>
                    <?php }else {?>  
                    <td class="qtty"> </td>
                    <td class="summ"><?php print formatprice($array_products [$countprod]["price"] * $array_products [$countprod]["quantity"]); ?></td>        
                    <?php }?>
                  </tr>
                <?php $countprod++; ?>
            <?php } ?>
            </table> 
            <table width = "100%">
            <tr>
                <td>
                  <span id = "wop_shop_quantity_products"><strong><?php print _WSHOP_CART_SUM_TOTAL?>:</strong>&nbsp;</span>&nbsp;
                </td>
                <td>
                  <span id = "wop_shop_summ_product"><?php print formatprice($cart->getSum(0,1))?></span>
                </td>
            </tr>
            <tr>
                <td colspan="2" align="right" class="goto_cart">
                  <a href = "<?php print Route::_("controller=cart&task=view", 1);?>"><?php print _WSHOP_CART_GO_TO_CART; ?></a>
                </td>
            </tr>
            </table>            
        </div>
        <?php echo $args['after_widget'];
    }
    
    public function form($instance) {
        $title     = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
        $_show_count     = isset( $instance['show_count'] ) ? $instance['show_count'] : 0;      
        $show_count = array();
        $show_count[] = HTML::_('select.option', '0', _WOP_SHOP_NO, 'show_count_id', 'show_count_value' );
        $show_count[] = HTML::_('select.option', '1', _WOP_SHOP_YES, 'show_count_id', 'show_count_value' );         
        ?>
        <p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" /></p>
        <p><label for="<?php echo $this->get_field_id( 'show_count' ); ?>"><?php echo _WSHOP_CART_SHOW_COUNT_OF_PRODUCT; ?></label>
		<?php echo HTML::_('select.genericlist', $show_count, 'show_count', 'class = "inputbox" size = "1"','show_count_id', 'show_count_value', esc_attr($_show_count)); ?></p>
    <?php 
    }
    
    public function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $show_count = Request::getInt('show_count');
        $new_instance = wp_parse_args( (array) $new_instance, array( 'title' => ''));
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['show_count'] = $show_count ? 1 : 0;

        return $instance;        
    }
}
